if [ ! -d "$GIT_DIR" ]; then
echo E: no repository found for "$REPO_NAME" >&2
- return 2
+ return 1
fi
export GIT_DIR
elif [ "$1" = 'run' ]; then
verbose "run begin"
- use "$2"
+ use "$2" || return 1
shift 2
"$@"
leave
# zle -N vcsh_exit
# bindkey '^d' 'vcsh_exit'
# fi
-# use $2
+# use "$2" || return 1
# [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
# verbose "use end"
# exit 0
echo " Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
exit 3
git merge origin/master
-# vcsh use $REPO_NAME
+# use $REPO_NAME || return 1
verbose "clone end"
elif [ "$1" = 'init' ]; then
export REPO_NAME="$2"
export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
init
-# vcsh use "$REPO_NAME"
+# use "$REPO_NAME" || return 1
verbose "init end"
#elif [ "$1" = 'exit' ]; then
elif [ "$1" = 'seed-gitignore' ]; then
verbose "seed-gitignore begin"
[ -z $2 ] && help && echo && echo "$SELF $1: error: please specify repository to work on" && return 0
- use "$2"
+ use $2 || return 1
# Switching directory as this has to be executed from $HOME to be of any use.
# Going back into old directory at the end in case `vcsh use` is reactivated.
old_dir="$PWD"
cd "$HOME"
git config core.excludesfile ".gitignore.d/$REPO_NAME"
- files=$(git ls-files)
gitignores=$(for file in $(git ls-files); do
while true; do
echo $file; new="${file%/*}"
file="$new"
done;
done | sort -u | sed 's/^/!/')
- [ -e "$HOME/.gitignore.d/$2" ] &&
- echo "$SELF: info: $HOME/.gitignore.d/$2 exists, moving it to $HOME/.gitignore.d/$2.bak" &&
- mv -f "$HOME/.gitignore.d/$2" "$HOME/.gitignore.d/$2.bak"
- echo '*' > "$HOME/.gitignore.d/$2"
+ tempfile=$(mktemp) ||
+ (echo "$SELF: fatal: could not create tempfile" && exit 1)
+ echo '*' > "$tempfile"
for gitignore in $gitignores; do
- echo "$gitignore" >> "$HOME/.gitignore.d/$2"
+ echo "$gitignore" >> "$tempfile"
done
+ diff -N "$tempfile" "$HOME/.gitignore.d/$2" > /dev/null &&
+ rm -f "$tempfile" &&
+ return
+ if [ -e "$HOME/.gitignore.d/$2" ]; then
+ echo "$SELF: info: $HOME/.gitignore.d/$2 differs from new data, moving it to $HOME/.gitignore.d/$2.bak"
+ mv -f "$HOME/.gitignore.d/$2" "$HOME/.gitignore.d/$2.bak" ||
+ (echo "$SELF: fatal: could not move $HOME/.gitignore.d/$2 to $HOME/.gitignore.d/$2.bak" && exit 1)
+ fi
+ mv -f "$tempfile" "$HOME/.gitignore.d/$2" ||
+ (echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$2" && exit 1)
cd "$old_dir"
+ verbose "seed-gitignore end"
+
+elif [ "$1" = 'delete' ]; then
+ verbose "delete begin"
+ REPO_NAME=$2
+ [ -z $REPO_NAME ] && help && echo && echo "$SELF $1: error: please specify repository to work on" && return 0
+ old_dir="$PWD"
+ cd "$HOME"
+ use $REPO_NAME || return 1
+ echo "$SELF: info: This operation WILL DETROY DATA!"
+ files=$(git ls-files)
+ echo "These files would be deleted:
+
+$files
+
+AGAIN, THIS WILL DELETE YOUR DATA!
+To continue, type \"Yes, do as I say\""
+ read answer
+ [ "x$answer" = "xYes, do as I say" ] || exit
+ for file in $files; do
+ rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
+ done
+ rm -rf "$VCSH_BASE/$REPO_NAME.git" || echo "$SELF: info: could not delete '$VCSH_BASE/$REPO_NAME.git'"
+ cd "$old_dir"
+ verbose "delete end"
+
else
verbose "defaulting to calling help()"